Horizontal Beeswarm in JavaScript

Using ApexCharts with JavaScript

This Horizontal Beeswarm example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
// A HORIZONTAL beeswarm: value on the X axis, one lane per department on Y.
// Every dot is a person's base pay. Each department gets its own hue (ordered so
// adjacent lanes separate well for colour-vision deficiency) and the eye reads
// each lane's spread, centre and outliers from the swarm shape.
// Figures are an illustrative sample (USD, base salary).
// Shared by the vanilla-js / React / Vue builds.
var DEPTS = [
  { name: 'Engineering', mean: 152, sd: 30, n: 34 },
  { name: 'Data Science', mean: 158, sd: 26, n: 22 },
  { name: 'Product', mean: 141, sd: 22, n: 18 },
  { name: 'Design', mean: 118, sd: 20, n: 20 },
  { name: 'Sales', mean: 112, sd: 34, n: 30 },
  { name: 'Support', mean: 74, sd: 12, n: 26 },
]

// Deterministic normal-ish sample (Irwin-Hall via an LCG): stable across
// re-renders and SSR, no Math.random. Rounded to the nearest $1k, floored so no
// dot dips below a plausible wage.
function swarm(mean, sd, n, seed) {
  var out = []
  var s = seed >>> 0
  function u() {
    s = (s * 1664525 + 1013904223) >>> 0
    return s / 4294967296
  }
  for (var i = 0; i < n; i++) {
    var g = 0
    for (var k = 0; k < 6; k++) g += u()
    var z = (g - 3) / Math.sqrt(0.5)
    out.push(Math.max(48, Math.round(mean + z * sd)))
  }
  return out
}

var paySeries = DEPTS.map(function (d, i) {
  return {
    name: d.name,
    data: swarm(d.mean, d.sd, d.n, 41 + i * 977).map(function (v, j) {
      return { name: d.name + ' #' + (j + 1), value: v }
    }),
  }
})

var options = {
  series: paySeries,
  chart: {
    id: 'salarySwarm',
    type: 'unit',
    height: 470,
    fontFamily: 'inherit',
    animations: {
      enabled: true,
      speed: 700,
    },
  },
  // One hue per team, ordered so adjacent lanes stay far apart for colour-vision
  // deficiency (validated: worst adjacent pair ΔE 9.2 CVD / 27.6 normal). The lane
  // label repeats the colour, so identity never rests on hue alone.
  colors: ['#008300', '#2a78d6', '#eb6834', '#1baf7a', '#4a3aa7', '#e87ba4'],
  legend: {
    position: 'bottom',
    markers: { radius: 12 },
  },
  plotOptions: {
    unit: {
      layout: 'scatter',
      size: 4,
      scatter: {
        orientation: 'horizontal',
        spread: 'swarm',
        xMin: 40,
        xMax: 240,
        tickAmount: 5,
        laneLabelWidth: 104,
        xTitle: 'Base salary',
        xFormatter: function (v) {
          return '$' + v + 'k'
        },
      },
    },
  },
  tooltip: {
    enabled: true,
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

Horizontal Beeswarm in Angular

Using ApexCharts with Angular

This Horizontal Beeswarm example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  private DEPTS: any = [
          { name: 'Engineering', mean: 152, sd: 30, n: 34 },
          { name: 'Data Science', mean: 158, sd: 26, n: 22 },
          { name: 'Product', mean: 141, sd: 22, n: 18 },
          { name: 'Design', mean: 118, sd: 20, n: 20 },
          { name: 'Sales', mean: 112, sd: 34, n: 30 },
          { name: 'Support', mean: 74, sd: 12, n: 26 },
        ];

  private swarm = (mean: any, sd: any, n: any, seed: any): any => {
          var out = []
          var s = seed >>> 0
          function u() {
            s = (s * 1664525 + 1013904223) >>> 0
            return s / 4294967296
          }
          for (var i = 0; i < n; i++) {
            var g = 0
            for (var k = 0; k < 6; k++) g += u()
            var z = (g - 3) / Math.sqrt(0.5)
            out.push(Math.max(48, Math.round(mean + z * sd)))
          }
          return out
        };

  private paySeries: any = this.DEPTS.map(function (d, i) {
          return {
            name: d.name,
            data: this.swarm(d.mean, d.sd, d.n, 41 + i * 977).map(function (v, j) {
              return { name: d.name + ' #' + (j + 1), value: v }
            }),
          }
        });

  public chartOptions: Partial<ChartOptions> = {
          series: this.paySeries,
          chart: {
            id: 'salarySwarm',
            type: 'unit',
            height: 470,
            fontFamily: 'inherit',
            animations: {
              enabled: true,
              speed: 700,
            },
          },
          // One hue per team, ordered so adjacent lanes stay far apart for colour-vision
          // deficiency (validated: worst adjacent pair ΔE 9.2 CVD / 27.6 normal). The lane
          // label repeats the colour, so identity never rests on hue alone.
          colors: ['#008300', '#2a78d6', '#eb6834', '#1baf7a', '#4a3aa7', '#e87ba4'],
          legend: {
            position: 'bottom',
            markers: { radius: 12 },
          },
          plotOptions: {
            unit: {
              layout: 'scatter',
              size: 4,
              scatter: {
                orientation: 'horizontal',
                spread: 'swarm',
                xMin: 40,
                xMax: 240,
                tickAmount: 5,
                laneLabelWidth: 104,
                xTitle: 'Base salary',
                xFormatter: (v) => {
                  return '$' + v + 'k'
                },
              },
            },
          },
          tooltip: {
            enabled: true,
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}

Horizontal Beeswarm in Vue

Using ApexCharts with Vue

This Horizontal Beeswarm example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div class="wrap">
      <h1>What people earn, by team</h1>
      <p class="lead">
        One dot per employee, laned by department, placed on a single pay axis.
        The swarm packs equal pay side by side, so a wide bulge is a common
        salary and a lone dot far right is an outlier, the shape of each team's
        pay is visible at a glance.
      </p>

      <div class="card">
        <div id="chart">
          <apexchart
            type="unit"
            height="470"
            :options="chartOptions"
            :series="series"
          ></apexchart>
        </div>
      </div>

      <div class="note">
        A horizontal beeswarm is the default
        <code>plotOptions.unit.scatter</code> with
        <code>orientation: 'horizontal'</code>: value on X, one category lane
        per row on Y. Each team carries its own hue, ordered so neighbouring
        lanes stay easy to tell apart for colour-vision deficiency, and the lane
        label repeats that colour so identity never rests on hue alone. The unit
        chart is a premium type, without a license it renders with a trial
        watermark.
      </div>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

// A HORIZONTAL beeswarm: value on the X axis, one lane per department on Y.
// Every dot is a person's base pay. Each department gets its own hue (ordered so
// adjacent lanes separate well for colour-vision deficiency) and the eye reads
// each lane's spread, centre and outliers from the swarm shape.
// Figures are an illustrative sample (USD, base salary).
// Shared by the vanilla-js / React / Vue builds.
var DEPTS = [
  { name: 'Engineering', mean: 152, sd: 30, n: 34 },
  { name: 'Data Science', mean: 158, sd: 26, n: 22 },
  { name: 'Product', mean: 141, sd: 22, n: 18 },
  { name: 'Design', mean: 118, sd: 20, n: 20 },
  { name: 'Sales', mean: 112, sd: 34, n: 30 },
  { name: 'Support', mean: 74, sd: 12, n: 26 },
]

// Deterministic normal-ish sample (Irwin-Hall via an LCG): stable across
// re-renders and SSR, no Math.random. Rounded to the nearest $1k, floored so no
// dot dips below a plausible wage.
function swarm(mean, sd, n, seed) {
  var out = []
  var s = seed >>> 0
  function u() {
    s = (s * 1664525 + 1013904223) >>> 0
    return s / 4294967296
  }
  for (var i = 0; i < n; i++) {
    var g = 0
    for (var k = 0; k < 6; k++) g += u()
    var z = (g - 3) / Math.sqrt(0.5)
    out.push(Math.max(48, Math.round(mean + z * sd)))
  }
  return out
}

var paySeries = DEPTS.map(function (d, i) {
  return {
    name: d.name,
    data: swarm(d.mean, d.sd, d.n, 41 + i * 977).map(function (v, j) {
      return { name: d.name + ' #' + (j + 1), value: v }
    }),
  }
})

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: paySeries,
      chartOptions: {
        chart: {
          id: 'salarySwarm',
          type: 'unit',
          height: 470,
          fontFamily: 'inherit',
          animations: {
            enabled: true,
            speed: 700,
          },
        },
        // One hue per team, ordered so adjacent lanes stay far apart for colour-vision
        // deficiency (validated: worst adjacent pair ΔE 9.2 CVD / 27.6 normal). The lane
        // label repeats the colour, so identity never rests on hue alone.
        colors: [
          '#008300',
          '#2a78d6',
          '#eb6834',
          '#1baf7a',
          '#4a3aa7',
          '#e87ba4',
        ],
        legend: {
          position: 'bottom',
          markers: { radius: 12 },
        },
        plotOptions: {
          unit: {
            layout: 'scatter',
            size: 4,
            scatter: {
              orientation: 'horizontal',
              spread: 'swarm',
              xMin: 40,
              xMax: 240,
              tickAmount: 5,
              laneLabelWidth: 104,
              xTitle: 'Base salary',
              xFormatter: function (v) {
                return '$' + v + 'k'
              },
            },
          },
        },
        tooltip: {
          enabled: true,
        },
      },
    }
  },
}
</script>

<style>
body {
  font-family:
    -apple-system, BlinkMacSystemFont, 'Segoe UI', Roboto, sans-serif;
  background: #fafbfc;
  color: #222b36;
  margin: 0;
  padding: 32px 16px;
}
.wrap {
  max-width: 760px;
  margin: 0 auto;
}
h1 {
  font-size: 22px;
  letter-spacing: -0.01em;
  margin: 0 0 6px;
}
.lead {
  color: #5b6b78;
  line-height: 1.55;
  margin: 0 0 18px;
  font-size: 14px;
}
.card {
  background: #fff;
  border: 1px solid #eef1f4;
  border-radius: 12px;
  padding: 16px 14px 8px;
  box-shadow:
    0 1px 3px rgba(20, 30, 45, 0.05),
    0 8px 24px rgba(20, 30, 45, 0.04);
}
.note {
  background: #f4f7fb;
  border-left: 3px solid #2a78d6;
  padding: 12px 16px;
  font-size: 13px;
  color: #37424e;
  border-radius: 2px;
  line-height: 1.65;
  margin: 22px 0 0;
}
.note code {
  background: #e4ecf7;
  padding: 1px 5px;
  border-radius: 3px;
  font-size: 12px;
}
</style>

Horizontal Beeswarm in React

Using ApexCharts with React

This Horizontal Beeswarm example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

// A HORIZONTAL beeswarm: value on the X axis, one lane per department on Y.
// Every dot is a person's base pay. Each department gets its own hue (ordered so
// adjacent lanes separate well for colour-vision deficiency) and the eye reads
// each lane's spread, centre and outliers from the swarm shape.
// Figures are an illustrative sample (USD, base salary).
// Shared by the vanilla-js / React / Vue builds.
var DEPTS = [
  { name: 'Engineering', mean: 152, sd: 30, n: 34 },
  { name: 'Data Science', mean: 158, sd: 26, n: 22 },
  { name: 'Product', mean: 141, sd: 22, n: 18 },
  { name: 'Design', mean: 118, sd: 20, n: 20 },
  { name: 'Sales', mean: 112, sd: 34, n: 30 },
  { name: 'Support', mean: 74, sd: 12, n: 26 },
]

// Deterministic normal-ish sample (Irwin-Hall via an LCG): stable across
// re-renders and SSR, no Math.random. Rounded to the nearest $1k, floored so no
// dot dips below a plausible wage.
function swarm(mean, sd, n, seed) {
  var out = []
  var s = seed >>> 0
  function u() {
    s = (s * 1664525 + 1013904223) >>> 0
    return s / 4294967296
  }
  for (var i = 0; i < n; i++) {
    var g = 0
    for (var k = 0; k < 6; k++) g += u()
    var z = (g - 3) / Math.sqrt(0.5)
    out.push(Math.max(48, Math.round(mean + z * sd)))
  }
  return out
}

var paySeries = DEPTS.map(function (d, i) {
  return {
    name: d.name,
    data: swarm(d.mean, d.sd, d.n, 41 + i * 977).map(function (v, j) {
      return { name: d.name + ' #' + (j + 1), value: v }
    }),
  }
})

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: paySeries,
    options: {
      chart: {
        id: 'salarySwarm',
        type: 'unit',
        height: 470,
        fontFamily: 'inherit',
        animations: {
          enabled: true,
          speed: 700,
        },
      },
      // One hue per team, ordered so adjacent lanes stay far apart for colour-vision
      // deficiency (validated: worst adjacent pair ΔE 9.2 CVD / 27.6 normal). The lane
      // label repeats the colour, so identity never rests on hue alone.
      colors: [
        '#008300',
        '#2a78d6',
        '#eb6834',
        '#1baf7a',
        '#4a3aa7',
        '#e87ba4',
      ],
      legend: {
        position: 'bottom',
        markers: { radius: 12 },
      },
      plotOptions: {
        unit: {
          layout: 'scatter',
          size: 4,
          scatter: {
            orientation: 'horizontal',
            spread: 'swarm',
            xMin: 40,
            xMax: 240,
            tickAmount: 5,
            laneLabelWidth: 104,
            xTitle: 'Base salary',
            xFormatter: function (v) {
              return '$' + v + 'k'
            },
          },
        },
      },
      tooltip: {
        enabled: true,
      },
    },
  })

  return (
    <div>
      <div className="wrap">
        <h1>What people earn, by team</h1>
        <p className="lead">
          One dot per employee, laned by department, placed on a single pay
          axis. The swarm packs equal pay side by side, so a wide bulge is a
          common salary and a lone dot far right is an outlier, the shape of
          each team's pay is visible at a glance.
        </p>

        <div className="card">
          <div id="chart">
            <ReactApexChart
              options={state.options}
              series={state.series}
              type="unit"
              height={470}
            />
          </div>
        </div>

        <div className="note">
          A horizontal beeswarm is the default{' '}
          <code>plotOptions.unit.scatter</code>
          with <code>orientation: 'horizontal'</code>: value on X, one category
          lane per row on Y. Each team carries its own hue, ordered so
          neighbouring lanes stay easy to tell apart for colour-vision
          deficiency, and the lane label repeats that colour so identity never
          rests on hue alone. The unit chart is a premium type, without a
          license it renders with a trial watermark.
        </div>
      </div>
    </div>
  )
}

export default ApexChart